		device pentagon1024

Vid_page		equ #a0
Tile_page		equ #9f

title_page		equ #20
sprites_page		equ #30
background_page		equ #29
def_page0		equ #10
func_page		equ #15	; page for this functions
music_page		equ #22
dig_scr_page		equ #23
my_stack		equ #ffff	
spr_copy		equ #ed00

left=4
right=0
up=2
down=6
fire=1	; ???
stop=#ff

	struct spr_param
x_width		byte
y_width		byte
x_trim		byte
y_trim		byte
X		word
y		byte	
	ends

		org #f000
begin
		di
		ld sp,#efff
		xor a
		ld bc,HSINT
		out (c),a
		ld b,high VSINTL
		out (c),a
		ld b,high VSINTH
		out (c),a
		ld e,7
		ld b,#40
		out (c),a
		inc b
		dec e
		jr nz,$-4
		call spr_off
		ld a,#ee
		ld i,a
		ld hl,int
		ld (#eeff),hl
		im 2
		call dig_screen
		ld hl,#11
		ld de,0
		ld bc,#2000
		ldir
		ld a,#10
		ld bc,PAGE0
		out (c),a
		inc a
		ld b,high PAGE1
		out (c),a
		inc a
		ld bc,PAGE2
		out (c),a

//		jr ss
		ld hl,rel
		ld de,#100
		ld bc,rel_end-rel
		ldir
		ei
		ld b,8
		halt
		djnz $-1
		ld a,#c9
		ld (0),a
		jp #103

MEDRES			jp MEDRES_proc
CLEAR_VIDEO_SCREEN	jp CLEAR_VIDEO_SCREEN_proc
SHOW_TITLE_PIC		jp SHOW_TITLE_PIC_proc
SET_PALETTE		jp SET_PALETTE_proc
PRINT_CHAR		jp PRINT_CHAR_proc
PUT_GFX_SPRITE		jp PUT_GFX_SPRITE_proc
SPRITE_INIT		jp SPRITE_INIT_proc
SPRITE_PLACE		jp SPRITE_PLACE_proc
SPRITE_MOVE		jp SPRITE_MOVE_proc
CHECK_FIRE_KEY		jp CHECK_FIRE_KEY_proc
CHECK_ARROW_KEY		jp CHECK_ARROW_KEY_proc
INIT_PT_MUSIC		jp INIT_PT_MUSIC_proc
SFX_PLAY		jp SFX_PLAY_proc
STOP_PT_MUSIC		jp STOP_PT_MUSIC_proc
SET_SPRITES		jp SET_SPRITES_proc
SPRITE_ERASE		jp SPRITE_ERASE_proc
RND_GEN			jp RND_GEN_proc
SPRITE_CHANGE		jp SPRITE_CHANGE_proc
BRDR			JP BORDER_proc
CHECK_POINT		jp CHECK_POINT_proc
/*
ss		call MEDRES
		call SET_PALETTE
		ld hl,#0000		;1111 - 
		call CLEAR_VIDEO_SCREEN1
		ld hl,sprinit1
		call SPRITE_INIT1
		ld hl,spr1
		call SPRITE_PLACE1
		jr $

sprinit1	db 1,14
spr1		db 1
		dw #0020
		db #20

1		ld hl,tst1
		call SPRITE_INIT1
		jr 1b

tst1		db 4,68

; Test unit
ss		call MEDRES		
		call SET_PALETTE
		call SHOW_TITLE_PIC

1		ld bc,100
		ld de,0
		ld a,1
		call PUT_GFX_SPRITE1
		jr $ 

*/

CHECK_POINT_proc
		ld hl,#2
		add hl,sp
		ld (restore_stack+1),sp
		ld sp,my_stack

		ld c,(hl)	; x
		inc hl
		ld b,(hl)
		inc hl
		ld e,(hl)	; y
		ld d,0
		ex de,hl
		call crd2pixaddr256c
		ld bc,PAGE0
		out (c),a
		ld a,(de)
		and #f3
		ld l,a
		ld a,def_page0
		out (c),a
		jp restore_stack

dig_screen	ld hl,#8080
		call CLEAR_VIDEO_SCREEN1
		ld hl,dig_scr_pal
		call set_ports
		ld hl,dig_scr_pic
		call set_ports
		ld hl,dig_scr_ts
		call set_ports
1		call CHECK_FIRE_KEY_proc
		ld a,l
		or a
		jr z,1b
		ld bc,PAGE0
		ld a,music_page
		out (c),a
		ld hl,spr_db
		ld de,spr_copy
		ld bc,spr_db_end-spr_db
		ldir
		ret


BORDER_proc	ld hl,#2
		add hl,sp
		ld a,(hl)	; x
		ld bc,BORDER
		out (c),a
		ret
/*
sp_put(x,y,image,outline,x_width,y_width);
u8 y, x_width, y_width;
int x 

char	*image, *outline;
        x, y - coordinates of image
     x_width - x width of image
     y_width - y width of image
      *image - address of image array
    *outline - address of outline array

Description:
	This routine will place the specified sprite on the screen and is
	then forgotten. It is then part of the background. This is used
	for screen initialization to place permanent objects on the screen.
	Note that the outline array is still needed and used.

HL - Y-,
BC - X-.

sp_put(int x,u8 y,u8 image);
*/

PUT_GFX_SPRITE_proc
		ld hl,#2
		add hl,sp
;		ld (restore_stack+1),sp
;		ld sp,my_stack

		ld c,(hl)	; x
		inc hl
		ld b,(hl)
		inc hl
		ld e,(hl)	; y
		ld d,0
		inc hl
		ld a,(hl)	; img
PUT_GFX_SPRITE1	push ix
		push af
		ex de,hl
		call crd2pixaddr256c
		ld ix,put_gfx_src
		ld (ix+7),e	; de: video adr
		ld (ix+9),d
		ld (ix+11),a
		pop af
		add a
		add a
		ld c,a
		ld b,0
		ld hl,put_img_list
		add hl,bc
		ld a,(hl)
		ld (ix+1),a	; char sprite adr
		inc hl
		ld a,(hl)
		ld (ix+3),a
		inc hl

		ld a,(hl)
		ld (ix+13),a	; sprite width
		inc hl
		ld a,(hl)
		ld (ix+15),a	; sprite height
		pop ix
		ld hl,put_gfx_src
		call set_ports
;		jp restore_stack
	ret




/*
	put(x,y,image,color);
int	x, y, color;
char	*image;

Description:

	This routine will place an image at the specified location. Note that
	the x and y widths are stored as the first two elements of the image
	array. Also there is no outline array used for this type of put. This
	put is basically used placing text and scoring on the screen. Each
	pixel will be and'd with the value of `color'. If the image is stored
	as white/yellow, then the image can be plotted in cyan/green or magenta/red
	depending on the value of `color'.


*/
PRINT_CHAR_proc	; (char chr,int x,int y,int color)
		ld hl,#2
		add hl,sp
		ld a,(hl)	; chr
		inc hl

		ld c,(hl)	; x
		inc hl
		ld b,(hl)	
		inc hl

		ld e,(hl)	; y
		inc hl
		ld d,(hl)	
;		inc hl

;		ld b,(hl)	; color
PRINT_CHAR1	push ix
		push de
		ld ix,pr_char_src
		ld hl,#c000
		cp " "
		jr z,2f
		ld l,16*2
		cp "_"
		jr z,2f
		cp "A"
		jr nc,1f

		ld l,8*2
		cp "."
		jr z,2f
		ld l,24*2
		cp ":"
		jr z,2f
		cp "0"-1
		jr c,4f
		sub "0"
4		ld l,#50*2	; #c050 DIGIT sprites
		jr 3f

1		ld hl,#e000
		sub "A"
3		ex de,hl
		ld l,a
		ld h,0
		add hl,hl
		add hl,hl
		add hl,hl
		add hl,hl
		add hl,de
2		ld (ix+1),l	; hl: char sprite adr
		ld (ix+3),h
		pop hl
		call crd2pixaddr256c

		ld (ix+7),e	; de: video adr
		ld (ix+9),d
		ld (ix+11),a
		pop ix
		ld hl,pr_char_src
		jp set_ports


CLEAR_VIDEO_SCREEN_proc	ld hl,#0		;1111 - 
			ld a,l
//			and #0f
			ld bc,BORDER
			out (c),a
CLEAR_VIDEO_SCREEN1	ld a,Vid_page
			ld bc,PAGE0
			out (c),a
			ld (#0000),hl
			ld hl,clr_screen
			call set_ports
			ld a,def_page0
			ld bc,PAGE0
			out (c),a
			ret

SHOW_TITLE_PIC_proc	ld hl,enhance_pal
			call set_ports
			ld hl,title_pic
			jp set_ports

SET_PALETTE_proc	ld hl,#2
			add hl,sp
			ld a,(hl)
			ld hl,enhance_pal
			or a
			jr z,1f
			ld hl,flash_pal
1			jp set_ports

MEDRES_proc		ld hl,sfx
			call AFXINIT
			ld hl,init_ts
			jp set_ports

SPRITE_MOVE_proc
			ld hl,#2
			add hl,sp
			ld (restore_stack+1),sp
			ld sp,my_stack
			exa
			ld a,(hl)	; num
			ld (store_xy1+1),a
			ld (collision_sprite+1),a
			exa
			inc hl
			ld c,(hl)	; int X
			inc hl
			ld b,(hl)
			inc hl
			ld a,(hl)	; u8 Y
			call store_xy
			call SPRITE_PLACE1
//			ld hl,0				; collision check!
//			ret
; ----------  Return Collision Information  ----------
;
; Description:
;
;	This routine will check to see if a sprite pointed to by bx
;	is overlapping the present sprite under use pointed to by si
;	after the trim factors have been taken into account for.


collision_sprite	ld a,0
			ld (col_sprite_main+1),a
			push ix
			call select_spr_param
			push hl
			pop ix

			ld hl,0
			ld (collision_sprite1+1),hl
			xor a
			ld (col_sprite_curr+1),a

			ld a,(collision_sprite+1)
			cp #0f
			jr nz,1f

			ld de,4
			call spr_left_pos
			sbc hl,de
			ld (main_spr_left+1),hl
			ld (main_spr_left2+1),hl
			call spr_right_pos
			add hl,de
			ld (main_spr_right+1),hl
			ld (main_spr_right2+1),hl

			call spr_top_pos
			sub 5
			ld (main_spr_top+1),a
			ld (main_spr_top2+1),a
			call spr_bottom_pos		
			add 3
			ld (main_spr_bottom+1),a
			ld (main_spr_bottom2+1),a

			jr col_sprite_curr

1			call spr_left_pos
			ld (main_spr_left+1),hl
			ld (main_spr_left2+1),hl
			call spr_right_pos
			ld (main_spr_right+1),hl
			ld (main_spr_right2+1),hl

			call spr_top_pos
			ld (main_spr_top+1),a
			ld (main_spr_top2+1),a
			call spr_bottom_pos		
			ld (main_spr_bottom+1),a
			ld (main_spr_bottom2+1),a

col_sprite_curr		ld a,0
col_sprite_main		cp 0
			jr z,main_col_sprite	; main sprite == main sprite
			cp #10
			jr z,collision_sprite_ex

			call select_spr_param
			ld a,(hl)
			cp #ff
			jr z,main_col_sprite	;spr_not_active
			push hl
			pop ix

			call spr_right_pos
			ld (cur_spr_right_pos+1),hl
			ex de,hl
main_spr_right		ld hl,0
			sbc hl,de
			jr z,check_Y
			jr c,check_spr_left	;
cur_spr_right_pos	ld de,0
main_spr_left		ld hl,0
			sbc hl,de
			jr c,check_Y	;exit;  cur.X > main.X_left


check_spr_left		call spr_left_pos
			ld (cur_spr_left_pos+1),hl
			ex de,hl
main_spr_right2		ld hl,0
			sbc hl,de
			jr c,main_col_sprite	;exit;  cur.X < main.X_right

cur_spr_left_pos	ld de,0
main_spr_left2		ld hl,0
			sbc hl,de
			jr c,check_Y
			jr main_col_sprite	;exit;  cur.X > main.X_left

check_Y			call spr_top_pos
			ld b,a
main_spr_bottom		ld a,0
			sub b
			jr z,spr_collision
			jr c,main_spr_bot_ch
main_spr_top		ld a,0
			sub b
			jr c,spr_collision

main_spr_bot_ch		call spr_bottom_pos		
			ld b,a
main_spr_bottom2	ld a,0
			sub b
			jr c,main_col_sprite
main_spr_top2		ld a,0
			sub b
			jr z,spr_collision
			jr nc,main_col_sprite


spr_collision		scf
			jr collision_sprite1

main_col_sprite		or a	; main sprite
collision_sprite1	ld hl,0	
			rr h
			rr l
			ld (collision_sprite1+1),hl
			ld hl,col_sprite_curr+1
			inc (hl)
			jr col_sprite_curr

collision_sprite_ex	ld hl,(collision_sprite1+1)
			pop ix
restore_stack		ld sp,0
			ret



spr_left_pos		ld hl,(ix+spr_param.X)
;			ld c,(ix+spr_param.x_trim)
;			add hl,bc
			inc hl
			ret

spr_right_pos		ld hl,(ix+spr_param.X)
			ld b,0
			ld c,(ix+spr_param.x_width)
			add hl,bc	
;			ld c,(ix+spr_param.x_trim)
;			or a
;			sbc hl,bc
			dec hl
			ret

spr_bottom_pos		ld a,(ix+spr_param.y)
			ld c,(ix+spr_param.y_width)
			add c	
;			ld c,(ix+spr_param.y_trim)
;			sub c
			dec a
			ret

spr_top_pos		ld a,(ix+spr_param.y)
;			ld c,(ix+spr_param.y_trim)
;			add c
			inc a
			ret

store_xy		push af
			push bc
store_xy1		ld a,0
			add a
			add a
			add a
			ld d,0
			ld e,a
			ld hl,sprites_param_db
			add hl,de
			ld e,4
			add hl,de
			pop bc
			pop af
			ld (hl),c
			inc hl
			ld (hl),b
			inc hl
			ld (hl),a
			ret

// sp_erase
SPRITE_ERASE_proc	ld hl,#2
			add hl,sp
			ld (restore_stack+1),sp
			ld sp,my_stack
			ld a,(hl)	; num
			ld (store_xy1+1),a
			push af
			call select_sprite
			inc hl
			res 5,(hl)
			pop af
			ld c,#ff	// sprite not active
			call store_xy
			jp restore_stack

/*
	n - sprite number (0 to 15) - collision information is returned
	x - x location of sprite
	y - y location of sprite

Description:

	The sprite specified by n is placed on the screen at location x,y. Background
	information is stored in the background buffer. Movement of the sprite requires
	the use of the sp_move command. Collision information is returned.

void sp_place(u8 n,int x,u8 y) */

SPRITE_PLACE_proc	ld hl,#2
			add hl,sp
			ld (restore_stack+1),sp
			ld sp,my_stack

			exa
			ld a,(hl)	; num
			ld (store_xy1+1),a
			exa
			inc hl
			ld c,(hl)	; int X
			inc hl
			ld b,(hl)
			inc hl
			ld a,(hl)	; u8 Y
			push af
			call store_xy
			call SPRITE_PLACE1

			ld a,(store_xy1+1)
			call select_sprite
			ld hl,spr_copy
			add hl,de
			pop af
			call SPRITE_PLACE2
			jp restore_stack


SPRITE_PLACE1		exa
			call select_sprite
			exa
SPRITE_PLACE2		ld (hl),a	; spr Y
			inc hl
			ld (hl),SP_SIZE16+SP_ACT
			inc hl
			ld a,c		; spr X
			ld (hl),a
			inc hl
			ld a,(hl)
			and #fe
			or b
			ld (hl),a
			ret


// void sp_chnge (u8 n, u8 image, u8 x_width, u8 y_width, u8 x_trim, u8 y_trim)
SPRITE_CHANGE_proc	ld a,0
			jr SPRITE_INIT_proc1

// void sp_init (u8 n, u8 image, u8 x_width, u8 y_width, u8 x_trim, u8 y_trim);
SPRITE_INIT_proc	ld a,1
SPRITE_INIT_proc1	ld (SPRITE_INIT_act_sw+1),a
			ld hl,#2
			add hl,sp
			ld (restore_stack+1),sp
			ld sp,my_stack

SPRITE_INIT1		ld a,(hl)	; num
			ld (SPRITE_INIT2+1),a
			inc hl
			ld a,(hl)	; tile
			ld (SPRITE_INIT3+1),a
			inc hl
			ld c,(hl)	; x_width
			or a
			rl c
			rl c		; multiply width by 4 (4 pixels per byte)
			inc hl
			ld b,(hl)	; y_width
			inc hl
			ld e,(hl)	; x_trim
			inc hl
			ld d,(hl)	; y_trim
			ld a,(SPRITE_INIT2+1)			
			push de
			call select_spr_param
			pop de
			ld (hl),c
			inc hl
			ld (hl),b
			inc hl
			ld (hl),e
			inc hl
			ld (hl),d

SPRITE_INIT2		ld a,0
			call select_sprite
			inc hl
SPRITE_INIT_act_sw	ld a,0
			or a
			jr z,1f
			ld (hl),SP_SIZE16
1			inc hl
			inc hl
			inc hl	; spr_tiles pointer
SPRITE_INIT3		ld a,0
			bit 6,a
			jr z,1f
			add 64		; next tile row
1			ld (hl),a
			jp restore_stack


/*
			inc hl
			ld b,(hl)	
			inc hl

			ld e,(hl)	; y
			inc hl
			ld d,(hl)	
			inc hl
*/
SET_SPRITES_proc	ld (restore_stack+1),sp
			ld sp,my_stack
			ld hl,spr_db
			ld de,spr_copy
			ld bc,6
			ldir
			push ix
			push iy

			exa
			ld a,15
			
			ld bc,6
			ld ix,spr_db+6
			ld iy,spr_copy+6
0			exa

			ld a,(ix+0)		; Y
			cp (iy+0)
			jr z,2f
			jr c,3f
			inc (iy+0)
			jr 2f

3			dec (iy+0)

2			ld a,(ix+1)
			ld (iy+1),a

			ld l,(ix+2)		; X
			ld a,(ix+3)
			and 1
			ld h,a
			ld e,(iy+2)
			ld a,(iy+3)
			and 1
			ld d,a
			sbc hl,de
			jr z,1f
			jr c,2f
			inc de
			jr 3f
2			dec de

3			ld (iy+2),e
			ld a,d
			or SP_SIZE16
			ld (iy+3),a

1			ld a,(ix+4)
			LD (iy+4),A
			ld a,(ix+5)
			LD (iy+5),A
			add iy,bc
			add ix,bc

			exa
			dec a
			jr nz,0b
			exa
			pop iy
			pop ix
			// spr_copy
			ld hl,sprites
			call set_ports
			jp restore_stack



/* :
D -      (#00, #40, #80  #C0   0,1,2  3, )
E -    ,
HL - Y-,
BC - X-.
*/
crd2pixaddr16c	ld de,Vid_page
		ld a,l
		and #3f ; thanks for Buyan
		or d
		ld d,a
		add hl,hl
		add hl,hl
		ld a,h
		add a,e
		srl b
		rr c
		ld e,c
		ret
/* :
A -  ,   ,
DE -    ,
CF -    : 0 - , 1 - .
*/

crd2pixaddr256c
/* :
D -      (#00, #40, #80  #C0   0,1,2  3, )
E -    ,
HL - Y-,
BC - X-.
*/
		ld de,Vid_page
		ld a,l
		and #1f ; thanks for Buyan
		add a
		or d
		add b
		ld d,a
		add hl,hl
		add hl,hl
		add hl,hl
		ld a,h
		add a,e
		ld e,c
		ret
/* :
A -  ,   ,
DE -    ,
*/
select_sprite	xor #0f	
		add a		; find 
		ld e,a
		add a
		add e		; x 6
		ld e,a
		ld d,0		; sprite num
		ld hl,spr_db
		add hl,de
		ret

select_spr_param
		add a
		add a
		add a
		ld e,a
		ld d,0
		ld hl,sprites_param_db
		add hl,de
		ret

int		ld (rest_int_stack+1),sp
		ld sp,int_stack
		push af
		push iy
		push ix
		push hl
		push de
		push bc
music_sw	ld a,0
		or a
		call nz,PLAY_MUSIC
		call AFXFRAME
		pop bc
		pop de
		pop hl
		pop ix
		pop iy
		pop af
		ei
rest_int_stack	ld sp,0
		ret


SFX_PLAY_proc	ld hl,#2
		add hl,sp
		ld a,(hl)
		jp AFXPLAY

STOP_PT_MUSIC_proc
		xor a
		jr INIT_PT_MUSIC1

; a!=0  music start
INIT_PT_MUSIC_proc
		ld hl,#2
		add hl,sp
;		ld (restore_stack+1),sp
;		ld sp,my_stack
		
		ld a,(hl)	; music
		add a,a
		ld e,a
		ld d,0
		ld hl,music_table
		add hl,de
		ld e,(hl)
		inc hl
		ld h,(hl)
		ld l,e
INIT_PT_MUSIC1	ld (music_sw+1),a
		push ix
		push iy
		ld bc,PAGE0
		ld a,music_page
		out (c),a
		di
		call #0003
		ei
		ld bc,PAGE0
		ld a,#10
		out (c),a
		pop iy
		pop ix
;		jp restore_stack
		ret

music_table	dw 0,#086e,#2011,#2011,#086e

PLAY_MUSIC
		ld bc,PAGE0
		ld a,music_page
		out (c),a
		call #0005
		ld bc,PAGE0
		ld a,#10
		out (c),a
		ret 


CHECK_ARROW_KEY_proc
		ld l,right
		LD BC,#effe
		; cs 8
		IN A,(C)
		BIT 2,A
		ret z
		
		ld l,up
		IN A,(C)
		BIT 3,A
		ret z
		
		ld l,down
		;cs 6
		IN A,(C)
		BIT 4,A
		ret z

		ld l,left
		LD BC,#f7fe
		IN A,(C)
		;cs 5
		BIT 4,A
		ret z
		ld l,stop
		ret

CHECK_FIRE_KEY_proc
;space		
		ld l,fire
		LD BC,#7FFE
		IN A,(C)
		BIT 0,A
		ret z
		ld l,0
		ret

RND_GEN_proc	jp Galois16

sprites
		db #1a,low spr_copy
	        db #1b,high spr_copy
		db #1c,func_page
	        db #1d,0
	        db #1e,2
	        db #1f,0
	        db #26,(spr_db_end-spr_db)/2-1
	        db #28,0
		db #27,DMA_RAM_SFILE
		db #ff

put_gfx_src		db #1a,0
			db #1b,0
			db #1c,background_page
			db #1d,0
			db #1e,0
			db #1f,Vid_page
			db high DMALEN,12/2-1
			db high DMANUM,13-1
			db high DMACTR,DMA_BLT+DMA_ASZ+DMA_DALGN+DMA_SALGN
			db #ff

		; adress, width/height
pic_base	equ #c000+#a0*2
put_img_list	dw pic_base		// dig right
		db #10/2-1,#10-1
		dw pic_base+16*1	// dig left
		db #10/2-1,#10-1
		dw pic_base+16*2	// diamant 
		db #10/2-1,#10-1
		dw pic_base+16*3	// diamant empty
		db #10/2-1,#10-1

;track elements
		dw pic_base+#30*2
		db #8/2-1,#12-1
		dw pic_base+#30*2+4*2
		db #8/2-1,#12-1

		dw pic_base+#20*2
		db #18/2-1,#8-1
		dw pic_base+#1000+#20*2
		db #18/2-1,#8-1

		dw pic_base+#30*2+12*2
		db #18/2-1,#8-1
		dw pic_base+#1000+#30*2+12*2
		db #18/2-1,#8-1
; background
		dw pic_base+#48*2
		db #14/2-1,#4-1
		dw pic_base+#800+#48*2
		db #14/2-1,#4-1
		dw pic_base+#1000+#48*2
		db #14/2-1,#4-1
		dw pic_base+#1800+#48*2
		db #14/2-1,#4-1

		dw pic_base+#54*2
		db #14/2-1,#4-1
		dw pic_base+#800+#54*2
		db #14/2-1,#4-1
		dw pic_base+#1000+#54*2
		db #14/2-1,#4-1
		dw pic_base+#1800+#54*2
		db #14/2-1,#4-1

		dw #c040		; empty
		db #10/2-1,#10-3


pr_char_src		db #1a,0
			db #1b,0
			db #1c,background_page
			db #1d,0
			db #1e,0
			db #1f,Vid_page
			db high DMALEN,12/2-1
			db high DMANUM,13-1
			db high DMACTR,DMA_RAM+DMA_ASZ+DMA_DALGN+DMA_SALGN
			db #ff

dig_scr_ts		db #00,VID_256C+VID_320X200	; set to 320x200 color graphics
			db #01,Vid_page	;VPAGE
			db high PALSEL,0
			db high BORDER,#80
			db #ff

init_ts			db #00,VID_256C+VID_320X200	; set to 320x200 color graphics
			db #01,Vid_page	;VPAGE
			db #20,6	; SYSCONFIG
			db high TSCONFIG,TSU_SEN ;TSU_T0EN+TSU_T1EN;+TSU_T0ZEN +TSU_T1ZEN		; TSConfig
			db high SGPAGE, sprites_page
			db #ff
			
clr_screen		defb #1a,0	;
			defb #1b,0	;
			defb #1c,Vid_page	;
			defb #1d,0	;
			defb #1e,0	;
			defb #1f,Vid_page	;
			defb #28,#ff	;
			defb #26,#ff	;
			defb #27,%00000100
			db #ff

title_pic		db #1a,0
			db #1b,0
			db #1c,background_page+1
			db #1d,0
			db #1e,0
			db #1f,Vid_page
			db high DMALEN,320/2-1
			db high DMANUM,200-1
			db high DMACTR,DMA_RAM+DMA_ASZ+DMA_DALGN+DMA_SALGN
			db #ff

flash_pal	db #1a,low flash_pal_bin
	        db #1b,high flash_pal_bin
		db #1c,func_page
	        db #1d,0
	        db #1e,0
	        db #1f,0
	        db #26,#7f
	        db #28,0
		db #27,#84
		db #ff

enhance_pal	db #1a,low enhance_pal_bin
	        db #1b,high enhance_pal_bin
		db #1c,func_page
	        db #1d,0
	        db #1e,0
	        db #1f,0
	        db #26,#ff
	        db #28,0
		db #27,#84
		db #ff
/*
title_pal	db #1a,low title_pal_bin
	        db #1b,high title_pal_bin
		db #1c,func_page
	        db #1d,0
	        db #1e,0
	        db #1f,0
	        db #26,16*5-1
	        db #28,0
		db #27,#84
		db #ff
*/
dig_scr_pic	db #1a,0
		db #1b,0
		db #1c,dig_scr_page
		db #1d,0
		db #1e,#14
		db #1f,Vid_page
		db high DMALEN,320/2-1
		db high DMANUM,120-1
		db high DMACTR,DMA_RAM+DMA_ASZ+DMA_DALGN
		db #ff

dig_scr_pal	db #1a,low dig_scr_pal_bin
	        db #1b,high dig_scr_pal_bin
		db #1c,func_page
	        db #1d,0
	        db #1e,1
	        db #1f,0
	        db #26,128-1
	        db #28,0
		db #27,#84
		db #ff

		align 2

enhance_pal_bin	incbin "_spg/128.tga.pal"
		incbin "_spg/dig.tga.pal"	// , 8 pal
		incbin "_spg/bags.tga.pal"	// 
		incbin "_spg/bug.tga.pal"	// 
		incbin "_spg/bonus.tga.pal"	// 
		incbin "_spg/explode.tga.pal"	// 


flash_pal_bin	incbin "_spg/128_bright.tga.pal"


dig_scr_pal_bin	incbin "_spg/dgr_128.tga.pal"

		ALIGN 2

/*
Sprite pal:			 bits
Digger - dig_pal_num 		: #0001
Bags - bags_pal_num  		: #00fe
Bugs - bugs_pal_num  		: #3f00
bonus - bonus_pal_num		: #4000
explosion - explode_pal_num	: #8000

+1 - next sprites pic row
*/
dig_pal_num 	equ #80+1
bags_pal_num	equ #90+1	
bugs_pal_num	equ #a0+1
bonus_pal_num	equ #b0+1
explode_pal_num	equ #c0+1
spr_db	
/*
		DB 0
		DB %01000000	; leap
		DB 0
		DB %00010000
		DB 0
		DB %11100000

		
		DB 0
		DB %01000000	; leap
		DB 0
		DB %00010000
		DB 0
		DB %11100000
*/
// explosion
		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db explode_pal_num		; TNUM+256
// bonus
		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bonus_pal_num		; TNUM+256

// Bugs:
		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bugs_pal_num		; TNUM+256

		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bugs_pal_num		; TNUM+256
// 4

		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bugs_pal_num		; TNUM+256

		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bugs_pal_num		; TNUM+256

		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bugs_pal_num		; TNUM+256

		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bugs_pal_num		; TNUM+256

// 8
// Bags:
		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bags_pal_num		; TNUM+256

		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bags_pal_num		; TNUM+256

		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bags_pal_num		; TNUM+256

		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bags_pal_num		; TNUM+256
// 12

		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bags_pal_num		; TNUM+256

		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bags_pal_num		; TNUM+256

		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db bags_pal_num		; TNUM+256

// 
		db 0	;y
		db SP_SIZE16	;+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db dig_pal_num		; TNUM+256
// 16



spr_db_end
// dig		db "1 ._:D I G G E R"

		include "includes.asm"
		include "tsconfig.asm"

rel		incbin "_spg/00000100.BIN"
rel_end

		include "ayfxplay.a80"
;Ayfx samples
sfx		incbin "_spg/dig.afb"
		ds 32
int_stack
			; width, trim, X,y (7 bytes)
sprites_param_db	ds 18*8

		export MEDRES
		export CLEAR_VIDEO_SCREEN
		export SHOW_TITLE_PIC
		export SET_PALETTE
		export PRINT_CHAR
		export PUT_GFX_SPRITE
		export SPRITE_INIT
		export SPRITE_PLACE
		export SPRITE_MOVE
		export CHECK_FIRE_KEY
		export CHECK_ARROW_KEY
		export INIT_PT_MUSIC
		export SFX_PLAY
		export STOP_PT_MUSIC
		export SET_SPRITES
		export SPRITE_ERASE
		export RND_GEN
		export SPRITE_CHANGE
		export BRDR
		export CHECK_POINT
end

		display "Size ",/d,end-begin," bytes"
		savebin "_spg/func_enh.bin",begin,end-begin