		device pentagon1024

Tile0_spr_page		equ #98
Vid_page		equ #a0
Tile_page		equ #9f
Spr_page		equ #90

main_page		equ 2
music_page		equ #3f
back_page		equ #40
logo_page		equ #46
spr_pic_page		equ #48
sin			equ #7e00
sin_slow		equ #7d00
font_db			equ #7b00
scroll_pal_num		equ #40

		org #8000
begin
		di
		ld sp,#7fff
		xor a
		ld bc,HSINT
		out (c),a
		ld b,high VSINTL
		out (c),a
		ld b,high VSINTH
		out (c),a
		ld e,7
		ld b,#40
		out (c),a
		inc b
		dec e
		jr nz,$-4
		ld a,VID_NOGFX
		ld bc,VCONFIG
		out (c),a
		call spr_off
		ld a,#be
		ld i,a
		ld hl,int
		ld (#beff),hl
		im 2
		ld bc,PAGE3
		ld a,music_page
		out (c),a
		call #c000
		ld de,sin
		ld bc,128*256+127
		call SINMAKE
		ld de,sin_slow
		ld bc,8*256+8
		call SINMAKE

		ld ix,font_db
		ld hl,#0000
		ld de,#c0-20*2	; height 3 tiles (#40*3), width 2 tiles, 20 chars in row
		ld bc,20*256+5
fdb1		push bc
fdb2		ld (ix+0),l
		inc ix		
		ld (ix+0),h
		inc ix
		inc hl
		inc hl		; width 2 tiles
		djnz fdb2
		add hl,de
		pop bc
		dec c
		jr nz,fdb1
		ld hl,0
		call clear_tileset
		ld hl,spr_copy
		call set_ports
		ld hl,back_copy
		call set_ports
		ld hl,back_copy2
		call set_ports
		ld hl,logo_copy
		call set_ports
		ld hl,#c202+#204
		ld de,#1000
		ld bc,(248/8)*256+(152/8)
		ld a,Tile_page
		call tile_filler

		ld hl,var_copy
		call set_ports		
		ld hl,#d02c+#204
		ld de,#301f
		ld bc,(88/8)*256+(40/8)
		ld a,Tile_page
		call tile_filler

		ld hl,ts_copy
		call set_ports
		ld hl,#c102+#204
		ld de,#201f+#140
		ld bc,(128/8)*256+(40/8)
		ld a,Tile_page
		call tile_filler
		ld hl,pal_copy
		call set_ports
		ld hl,init_ts
		call set_ports

		ei
lp1		LD BC,#F7FE
		IN A,(C)
		BIT 0,A
		jr z,original_game
		BIT 1,A
		jr z,enhance_game
		LD BC,#BFFE
		IN A,(C)
		BIT 0,A
		jr nz,1f
		ld a,1
		ld (view_txt_block+1),a
		call view_txt_block
		ld b,8
		halt
		djnz $-1

1		halt
		jr lp1

original_game	ld a,#14
		jr _game

enhance_game	ld a,#15

_game
		halt
		push af
		
		ld a,VID_NOGFX
		ld bc,VCONFIG
		out (c),a
		xor a
		ld b,high TSCONFIG
		out (c),a
		ld b,high GYOFFSL
		out (c),a

		ld b,high PAGE3
		push bc
		ld a,music_page
		out (c),a
		call #c000
		pop bc
		pop af
//		ld bc,PAGE3
		out (c),a

		jp #f000

sprites_pos	ld hl,sin+#42
		inc l
		ld (sprites_pos+1),hl
		ld a,(hl)

		ld hl,sp_inc2+1
		inc (hl)
		ld hl,sp_inc1+1
		dec (hl)

sp_inc2		add #2e
		ld l,a
		ld h,high sin_slow
		ld ix,spr_db
		ld de,#28b8		; start x,y
		
		ld bc,#0310		; y strok, x chars
sprites_pos1	push bc
		ld a,(hl)
		ld c,a
		add e
		ld (ix+0),a

		ld c,l
		ld a,l
sp_inc1		add #1c
		ld l,a
		ld a,(hl)
		ld l,c
		add d
		ld (ix+2),a

		ld bc,6
		add ix,bc
		ld a,l
sp_sin		add 10
		ld l,a		
		pop bc
		ld a,d
		add #0d
		ld d,a
		dec c
		jr nz,sprites_pos1
		ld d,#28	; start x
		ld a,l
sp_sin1		add #18
		ld l,a
		ld a,e
		add #10
		ld e,a
		
		ld c,#10
		djnz sprites_pos1
		ret

view_txt_block	ld a,112
		dec a
		ld (view_txt_block+1),a
		ret nz
		call Galois16
		and #7
		add 8
		ld (sp_sin+1),a
		call Galois16
		ld (sprites_pos+1),a
		and #3f
		ld (sp_sin1+1),a

		ld ix,spr_db+4	;_end-2
		ld bc,6	;0-6
view_txt_block1	ld hl,text
		ld a,(hl)
		inc hl
		or a
		jr z,vc_ex		; end text block
vc2		cp #ff
		jr nz,vc3	; end all texts block
		ld hl,text
vc_ex		ld (view_txt_block1+1),hl
		ret

vc3		
		ld (view_txt_block1+1),hl
		sub #20
		add a,a
		ld l,a
		ld h,high font_db
		ld e,(hl)
		ld (ix+0),e
		inc hl
		ld a,(hl)
		or scroll_pal_num
		ld (ix+1),a
		add ix,bc
		jr view_txt_block1

//		   "1234567890abcdef"
text		DB "  Digger ",#40, "1983  "
		db "                "
		db "by Windmill soft",0
// 3 rows at all

		db "   Press 1 to   "
		db " start original "
		db "  game for MGA  ",0

		db "Digger Enhanced "
		db "                "
		db " for TS Config  ",0

		db "   Press 2 to   "
		db " start upgraded "
		db " ZX Enhanced ver",0 

		db " -Game ported-  "
		db " to Z80 CPU by  "
		db " Consciousness  ",0

		db "   Code: vbi    "
		db "Enhanced Gfx: Er"
		db "   Music: nq    ",0

		db "  -= Intro =-   "
		db " Digger logo by "
		db "  Baimu studio  ",0
		
		db " Music: wbcbz7  "
		db "  Design, code: "
		db "      vbi       ",0

		db " Big Thanks to: "
		db " Blade for his  "
		db "   help with C  ",0

		db "Greets to all ZX"
		db " Spectrum scene:"
		db " Hype, #Z80 IRC ",0

		db " tslabs, zxart  "
		db "  pouet, zx.pk  "
		db "   speccy.pl    ",0

		db "For all creative"
		db " people from ZX "
		db " Spectrum world!",0

		db " 02/11/2016-    "
		db "                "
		db "    14/12/2016  ",0

		db " Hacker VBI     "
		db "                "
		db "       Ukraine  ",#ff

		db #ff

int		push af
		push ix
		push hl
		push de
		push bc
sin_cnt		ld hl,sin
		inc l
		ld (sin_cnt+1),hl
		ld a,(hl)
		ld bc,GYOFFSL
		out (c),a
		ld hl,sprites
		call set_ports
		call sprites_pos
		call view_txt_block
		ld bc,PAGE3
		ld a,music_page
		out (c),a
		call #c005
		ld bc,PAGE3
		ld a,#10
		out (c),a
		pop bc
		pop de
		pop hl
		pop ix
		pop af
		ei
		ret


/*
CHECK_ARROW_KEY_proc
		ld l,right
		LD BC,#effe
		; cs 8
		IN A,(C)
		BIT 2,A
		ret z
		
		ld l,up
		IN A,(C)
		BIT 3,A
		ret z
		
		ld l,down
		;cs 6
		IN A,(C)
		BIT 4,A
		ret z

		ld l,left
		LD BC,#f7fe
		IN A,(C)
		;cs 5
		BIT 4,A
		ret z
		ld l,stop
		ret

CHECK_FIRE_KEY_proc
;space		
		ld l,fire
		LD BC,#7FFE
		IN A,(C)
		BIT 0,A
		ret z
		ld l,0
		ret
*/

back_copy	db #1a,0
		db #1b,0
		db #1c,back_page
		db #1d,0
		db #1e,0
		db #1f,Vid_page
		db high DMALEN,360/4-1
back_copy2	db high DMANUM,256-1
		db high DMACTR,DMA_RAM+DMA_DALGN
		db #ff

logo_copy	db #1a,0
		db #1b,0
		db #1c,logo_page
		db #1d,0
		db #1e,0
		db #1f,Tile0_spr_page
		db high DMALEN,248/4-1
		db high DMANUM,152-1
		db high DMACTR,DMA_RAM+DMA_DALGN
		db #ff

var_copy	db #1a,0
		db #1b,#0a
		db #1c,logo_page+1
		db #1d,#7c
		db #1e,0
		db #1f,Tile0_spr_page
		db high DMALEN,88/4-1
		db high DMANUM,40-1
		db high DMACTR,DMA_RAM+DMA_DALGN
		db #ff

ts_copy		db #1a,0
		db #1b,#12
		db #1c,logo_page+1
		db #1d,#7c
		db #1e,#28
		db #1f,Tile0_spr_page
		db high DMALEN,128/4-1
		db high DMANUM,40-1
		db high DMACTR,DMA_RAM+DMA_DALGN
		db #ff

spr_copy	db #1a,0
		db #1b,0
		db #1c,spr_pic_page
		db #1d,0
		db #1e,0
		db #1f,Spr_page
		db high DMALEN,320/4-1
		db high DMANUM,120-1
		db high DMACTR,DMA_RAM+DMA_DALGN
		db #ff



init_ts		db #00,VID_16C+VID_360X288	; set to 320x200 color graphics
		db #01,Vid_page	;VPAGE
		db #20,6	; SYSCONFIG
		db high TSCONFIG,TSU_T0ZEN+TSU_T0EN+TSU_SEN
		db high T0GPAGE,Tile0_spr_page
		db high SGPAGE,Spr_page
		db high TMPAGE,Tile_page
		db high PALSEL,0
		db high BORDER,8
		db high MEMCONFIG,%00001110
		db #ff
			
clr_screen	defb #1a,0	;
		defb #1b,0	;
		defb #1c,Vid_page	;
		defb #1d,0	;
		defb #1e,0	;
		defb #1f,Vid_page	;
		defb #28,#af	;
		defb #26,#7f	;
		defb #27,%00000100
		db #ff


pal_copy	db #1a,low pal_bin
	        db #1b,high pal_bin
		db #1c,main_page
	        db #1d,0
	        db #1e,0
	        db #1f,0
	        db #26,8*16-1
	        db #28,0
		db #27,#84
		db #ff

sprites
		db #1a,low spr_db
	        db #1b,high spr_db
		db #1c,2
	        db #1d,0
	        db #1e,2
	        db #1f,0
	        db #26,(spr_db_end-spr_db)/2-1
	        db #28,0
		db #27,DMA_RAM_SFILE
		db #ff

		align 2
pal_bin	;dup 5
		incbin "_gfx/back1.tga.pal"
		incbin "_gfx/logo.tga.pal"
		incbin "_gfx/ts.tga.pal"
		incbin "_gfx/var.tga.pal"
		incbin "_gfx/font.tga.pal4"

		include "../../includes.asm"
		include "../../tsconfig.asm"

		align 2
spr_db
		dup 48
		db 0	;y
		db SP_SIZE24+SP_ACT
		db 0		;x
		db SP_SIZE16
		db 0
		db scroll_pal_num
		edup
spr_db_end

end

		display "Size ",/d,end-begin," bytes"
		savebin "_spg/dcrack.bin",begin,end-begin